// ignore_for_file: non_constant_identifier_names
part of 'google_map_view.widget.dart';

class _IOSMapDelegate extends NSObject with _Callbacks, GMSMapViewDelegate {
  GMSMapView iosController;

  @override
  Future<bool> mapView_didTapMarker(
    GMSMapView mapView,
    GMSMarker marker,
  ) async {
    if (_onMarkerClicked != null) {
      await _onMarkerClicked(Marker.ios(marker, iosController));
    }
    return true;
  }

  @override
  Future<void> mapView_didChangeCameraPosition(
    GMSMapView mapView,
    GMSCameraPosition position,
  ) async {
    final location = await position.get_target();
    await _onMapMoveEnd?.call(
      MapMove(
        coordinate: LatLng(await location.latitude, await location.longitude),
        zoom: await position.get_zoom(),
        tilt: await position.get_viewingAngle(),
      ),
    );
  }
}

class _AndroidMapDelegate extends java_lang_Object
    with
        _Callbacks,
        com_google_android_gms_maps_GoogleMap_OnMarkerClickListener,
        com_google_android_gms_maps_GoogleMap_SnapshotReadyCallback,
        com_google_android_gms_maps_GoogleMap_OnCameraChangeListener {
  @override
  Future<bool> onMarkerClick(
    com_google_android_gms_maps_model_Marker var1,
  ) async {
    await _onMarkerClicked?.call(Marker.android(var1));
    return true;
  }

  @override
  Future<void> onSnapshotReady(android_graphics_Bitmap var1) async {
    _onSnapshot?.call(var1);
  }

  @override
  Future<void> onCameraChange(
    com_google_android_gms_maps_model_CameraPosition var1,
  ) async {
    final location = await var1.get_target();
    _onMapMoveEnd?.call(MapMove(
      coordinate: LatLng(
        await location.get_latitude(),
        await location.get_longitude(),
      ),
      zoom: await var1.get_zoom(),
      tilt: await var1.get_tilt(),
    ));
  }
}

mixin _Callbacks {
  OnMarkerClicked _onMarkerClicked;
  OnMapMove _onMapMoveEnd;
  void Function(android_graphics_Bitmap image) _onSnapshot;
}
